import axios from 'axios'

const newUrl = '/eiru_purchases/new'

const createUrl = '/eiru_purchases/create'

const actions = {
    /**
     * Get all resources to init purchase app
     * @param {*} param0 
     */
    initPurchase({ dispatch }) {
        return axios.get(newUrl).then(response => {
            dispatch('explodeData', response.data)
        }).catch(error => {
            console.log(error)
        })
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    explodeData({ commit, dispatch }, payload) {
        Object.keys(payload).forEach(key => {
            commit(`set${key[0].toLocaleUpperCase()}${key.slice(1)}`, payload[key])
        })
    },
    /**
     * Send data to create concrete purchase
     * @param {*} param0 
     */
    createPurchase({ commit, dispatch }) {
        return axios.post(createUrl, {

        }).then(response => {
            dispatch('resetPurchase')
        }).catch(error => {
            console.log(error)
        })
    },
    /**
     * Reset all default app state 
     * @param {*} param0 
     */
    resetPurchase({ state, commit }) {
        Object.keys(state).forEach(value => {
            Object.keys(state[value]).forEach(key => {
                commit(`set${key[0].toLocaleUpperCase()}${key.slice(1)}`, state[value][key].default)
            })
        })
    }
}

export default actions