const state = {
    paymentTerms: {
        default: [],
        values: this.default
    },
    amountPaid: {
        default: 0,
        value: 0
    },
    amountResidual: {
        default: 0,
        value: 0
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    paymentTerms(state) {
        return state.paymentTerms.values
    },
    /**
     * 
     * @param {*} state 
     */
    amountPaid(state) {
        return state.amountPaid.value
    },
    /**
     * 
     * @param {*} state 
     */
    amountResidual(state) {
        return state.amountResidual.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setPaymentTerms(state, payload) {
        state.paymentTerms.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setAmountPaid(state, payload) {
        state.amountPaid.value = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    computeAmountResidual(state, payload) {
        state.amountResidual.value = payload.paymentAmount >= payload.totalAmount ? payload.paymentAmount - payload.totalAmount : 0
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setAmountResidual(state, payload) {
        state.amountResidual.value = payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    changeAmountPaid({ commit, getters }, payload) {
        commit('setAmountPaid', payload)
        commit('computeAmountResidual', {
            totalAmount: getters.cartTotal,
            paymentAmount: payload
        })
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}