import axios from 'axios'

const url = '/eiru_purchases/new'

const state = {
    products: {
        default: [],
        values: []
    },
    productWithVariant: {
        default: null,
        value: null
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    products(state) {
        return state.products.values
    },
    /**
     * 
     * @param {*} state 
     */
    productWithVariant(state) {
        return state.productWithVariant.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setProducts(state, payload) {
        state.products.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setProductWithVariant(state, payload) {
        state.productWithVariant.value = value
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    setProducts({ commit }, payload) {
        commit('setProducts', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    selectProduct({ commit, dispatch }, payload) {
        if (payload.variantCount > 1) {
            commit('setProductWithVariant', payload)
            return
        }

        dispatch('addToCart', payload.variants[0])
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    selectProductVariant({ commit, dispatch }, payload) {
        commit('setProductVariant', null)

        if (!payload) return

        dispatch('addToCart', payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}